Index: other-projects/nightly-tasks/crons-and-scripts/windows/create-expeditee.bat
===================================================================
--- other-projects/nightly-tasks/crons-and-scripts/windows/create-expeditee.bat	(revision 32407)
+++ other-projects/nightly-tasks/crons-and-scripts/windows/create-expeditee.bat	(revision 32407)
@@ -0,0 +1,64 @@
+@echo off
+setlocal
+
+:: http://stackoverflow.com/questions/203090/how-to-get-current-datetime-on-windows-command-line-in-a-suitable-format-for-us
+for /f "tokens=2-4 delims=/ " %%a in ('date /t') do (set mydate=%%c-%%b-%%a)
+echo The current date is %mydate%
+
+
+:: currentdir (C:\Research\Nightly)
+set currentdir=%CD%
+
+:: Need to edit rke-setup.bat and fill it in with local env vars values
+if not exist %currentdir%\tools\expeditee-release-kits\rke-setup.bat (
+echo. 
+echo ******************* 
+echo. 
+echo First edit %currentdir%\tools\expeditee-release-kits\rke-setup.bat.in 
+echo to generate %currentdir%\tools\expeditee-release-kits\rke-setup.bat
+echo. 
+echo ******************* 
+echo. 
+goto end
+)
+
+:: rke-setup.bat uses local paths, so cd into expeditee-release-kits first
+:: then call rke-setup.bat to source the environment vars it sets
+pushd %currentdir%\tools\expeditee-release-kits
+call rke-setup.bat
+if ERRORLEVEL 1 (
+	echo error level 1 or more
+	popd	
+	exit /B 1
+)
+popd
+
+
+:: Make sure the expeditee folder and its rke-build.properties file exist
+:: Then run the 'rke' command from snapshots\expeditee
+pushd %currentdir%\snapshots
+::http://www.robvanderwoude.com/battech_ifexistfolder.php
+if exist expeditee\ echo Deleting snapshots\expeditee&& rmdir /s /q expeditee
+if not exist expeditee\ mkdir expeditee
+if not exist expeditee\rke-build.properties copy C:\Research\Nightly\tools\expeditee-release-kits\rke-build.properties.in expeditee\rke-build.properties
+pushd expeditee
+call rke
+
+:: Uploading
+mkdir uploads
+copy products\Expeditee-1%products_suffix%.exe uploads\Expeditee-1-%mydate%%uploads_suffix%.exe
+copy rke.out uploads\rke-%mydate%%os_suffix%-windows.out
+set PATH=C:\Windows\System32\linuxtools;C:\Program Files (x86)\PuTTY2;%PATH%
+:: Works from the cmd line:
+:: cd uploads && tar.exe -c * | plink.exe -T -i "C:\Research\Nightly\tools\keys\upload-expeditee.ppk" USER@MACHINE.cms.waikato.ac.nz
+
+:: The following setcmd ends up partially running the cmd and uploading everything in snapshots\expeditee onto the remote machine
+rem set upload_cmd=cd uploads && tar -c * | plink -T -i "C:\Research\Nightly\tools\keys\upload-expeditee.ppk" USER@MACHINE.cms.waikato.ac.nz
+rem echo %upload_cmd%
+cd uploads && tar -c * | plink -T -i "%identity_file%" anupama@wharariki.cms.waikato.ac.nz
+
+:end
+
+cd %currentdir%
+endlocal
+::exit
Index: other-projects/nightly-tasks/crons-and-scripts/windows/create-gs2-caveat.bat
===================================================================
--- other-projects/nightly-tasks/crons-and-scripts/windows/create-gs2-caveat.bat	(revision 32407)
+++ other-projects/nightly-tasks/crons-and-scripts/windows/create-gs2-caveat.bat	(revision 32407)
@@ -0,0 +1,3 @@
+set PERL_HOME=C:\strawberry-perl32no64\perl
+::C:\Perl64\bin\perl.exe -s c:\research\nightly\tools\envi\bin\envi.pl gs2-caveat %*
+%PERL_HOME%\bin\perl.exe -s c:\research\nightly\tools\envi\bin\envi.pl gs2-caveat %*
Index: other-projects/nightly-tasks/crons-and-scripts/windows/create-gs3-caveat.bat
===================================================================
--- other-projects/nightly-tasks/crons-and-scripts/windows/create-gs3-caveat.bat	(revision 32407)
+++ other-projects/nightly-tasks/crons-and-scripts/windows/create-gs3-caveat.bat	(revision 32407)
@@ -0,0 +1,3 @@
+rem C:\Perl64\bin\perl.exe -s c:\research\nightly\tools\envi\bin\envi.pl gs3-caveat %*
+set PERL_HOME=C:\strawberry-perl32no64\perl
+%PERL_HOME%\bin\perl.exe -s c:\research\nightly\tools\envi\bin\envi.pl gs3-caveat %*
Index: other-projects/nightly-tasks/crons-and-scripts/windows/gen-release.bat
===================================================================
--- other-projects/nightly-tasks/crons-and-scripts/windows/gen-release.bat	(revision 32407)
+++ other-projects/nightly-tasks/crons-and-scripts/windows/gen-release.bat	(revision 32407)
@@ -0,0 +1,1 @@
+C:\Perl64\bin\perl.exe -s c:\research\nightly\tools\envi\bin\envi.pl release %*
Index: other-projects/nightly-tasks/crons-and-scripts/windows/nightly-with-log.bat
===================================================================
--- other-projects/nightly-tasks/crons-and-scripts/windows/nightly-with-log.bat	(revision 32407)
+++ other-projects/nightly-tasks/crons-and-scripts/windows/nightly-with-log.bat	(revision 32407)
@@ -0,0 +1,4 @@
+@echo off
+
+rem C:\Perl64\bin\perl.exe -s C:\Research\Nightly\tools\envi\bin\envi.pl %1 > C:\Research\Nightly\logs\%1.out 2>&1
+C:\strawberry-perl32no64\perl\bin\perl.exe -s C:\Research\Nightly\tools\envi\bin\envi.pl %1 > C:\Research\Nightly\logs\%1.out 2>&1
Index: other-projects/nightly-tasks/crons-and-scripts/windows/run-gs2-diffcol.bat
===================================================================
--- other-projects/nightly-tasks/crons-and-scripts/windows/run-gs2-diffcol.bat	(revision 32407)
+++ other-projects/nightly-tasks/crons-and-scripts/windows/run-gs2-diffcol.bat	(revision 32407)
@@ -0,0 +1,4 @@
+@echo off
+rem C:\Perl64\bin\perl.exe -s c:\research\nightly\tools\envi\bin\envi.pl diffcol %*
+set PERL_HOME=C:\strawberry-perl32no64\perl
+%PERL_HOME%\bin\perl.exe -s c:\research\nightly\tools\envi\bin\envi.pl diffcol %*
Index: other-projects/nightly-tasks/crons-and-scripts/windows/setenv.bat
===================================================================
--- other-projects/nightly-tasks/crons-and-scripts/windows/setenv.bat	(revision 32407)
+++ other-projects/nightly-tasks/crons-and-scripts/windows/setenv.bat	(revision 32407)
@@ -0,0 +1,103 @@
+@echo off
+echo.
+echo ******************************
+
+:: https://spring.io/guides/gs/android/
+set ANDROID_HOME=C:\Apps\Android\adt\sdk
+::C:\Program Files (x86)\Android\android-studio\sdk
+set PATH=%ANDROID_HOME%\tools;%ANDROID_HOME%\platform-tools;%PATH%
+
+:: C:\Users\Anupama\tmp\myApp>npm install phonegap@latest
+:: phonegap
+:: cordova
+:: phonegap create myApp
+:: Make sure Android SDK and ANT are on PATH, then:
+:: cordova platform add android
+
+:: For notes on compiling GS2 on 64 bit Win 7 see 
+:: http://wiki.greenstone.org/doku.php?id=en:developer:compiling_apache&#compiling_the_apache-httpd_included_with_gs2_on_64_bit_windows_7
+
+:: The following JDK 6 is copied straight from the 32 bit Win machine into the 64 bit Win machine
+:: It was used to debug gli's GS3ServerThread's changeover to use Process.waitFor()
+::set JAVA_HOME=C:\Program Files (x86)\Java\jdk1.6.0_13& echo @@@@@@@@@ USING JAVA 6 @@@@@@@@@
+::set JAVA_HOME=C:\Program Files\Java\jdk1.7.0_55
+set JAVA_HOME=C:\Program Files\Java\jdk1.8.0_20
+if not exist "%JAVA_HOME%" echo %JAVA_HOME% does not exist& goto done
+set PATH=%JAVA_HOME%\bin;%PATH%
+
+echo + Set JAVA_HOME=%JAVA_HOME% and updated PATH
+
+rem set PERL_HOME=C:\Perl64
+set PERL_HOME=C:\strawberry-perl32no64\perl
+::if not exist "%PERL_HOME%" echo %PERL_HOME% does not exist& goto done
+set PATH=%PERL_HOME%\bin;%PATH%
+::set PATH=%PERL_HOME%\perl\site\bin;%PERL_HOME%\perl\bin;%PERL_HOME%\c\bin;%PATH%
+
+::echo + Set PERL_PATH=%PERL_HOME% and updated PATH
+
+set ANT_HOME=C:\apache-ant-1.9.4
+set PATH=%ANT_HOME%\bin;%PATH%
+::set PATH=%JAVA_HOME%\bin;%ANT_HOME%\bin;%PATH%
+::set PATH=%JAVA_HOME%\bin;%ANT_HOME%\bin;C:\Program Files (x86)\putty;C:\Windows\System32\UnxUtils\usr\local\wbin;%PATH%
+rem set PATH=%JAVA_HOME%\bin;%ANT_HOME%\bin;C:\Program Files (x86)\putty;C:\Windows\System32\linuxtools;%PATH%
+
+rem echo + Set ANT_HOME=%ANT_HOME% and updated PATH
+
+
+:: Setup Visual Studio env
+:: WORKS:
+::call "C:\Program Files (x86)\Microsoft Visual Studio 9.0\Common7\Tools\vsvars32.bat"
+
+:: Running VS in 64 bit mode doesn't work, need to run in 32 bit mode.
+:: For now only VS9.0 (VS2008) works
+:: call "C:\Program Files (x86)\Microsoft Visual Studio 9.0\Common7\Tools\vsvars32.bat"
+
+::::::set vslocation=C:\Program Files (x86)\Microsoft Visual Studio 9.0\Common7\Tools
+::::::if not exist "%vslocation%" echo %vslocation% does not exist& goto done
+::::::pushd "%vslocation%"
+::::::call vsvars32.bat
+::::::popd
+
+:: Running VS in 64 bit works for Visual Studio 12:
+set vslocation=C:\Program Files (x86)\Microsoft Visual Studio 12.0\VC
+if not exist "%vslocation%" echo %vslocation% does not exist& goto done
+pushd "%vslocation%"
+call vcvarsall.bat amd64
+popd
+
+rem pushd "C:\Program Files (x86)\Microsoft Visual Studio 9.0\VC"
+rem call vcvarsall.bat amd64
+rem popd
+
+:: VS10 fails: Common Tools folder not found for VS10
+rem call "C:\Program Files (x86)\Microsoft Visual Studio 10.0\VC\bin\vcvars32.bat"
+
+:: VS12 fails: Calling "vsvars32.bat" above produces the same error as calling
+:: C:\Program Files (x86)\Microsoft Visual Studio 12.0\VC\bin\amd64_x86\vcvarsamd64_x86.bat
+:: (and possibly the same error as calling
+:: C:\Program Files (x86)\Microsoft Visual Studio 12.0\VC\vcvarsall.bat without passing "amd64" param)
+rem call "C:\Program Files (x86)\Microsoft Visual Studio 12.0\Common7\Tools\vsvars32.bat"
+
+:: Error: https://groups.google.com/forum/#!topic/UniMRCP/Iybpn51UYnI
+:: http://msdn.microsoft.com/en-us/library/ff770576.aspx
+:: http://stackoverflow.com/questions/11544563/can-i-set-the-platform-toolset-from-the-command-line-when-building-with-vs2010s
+:: /p:PlatformToolset=v100
+
+
+:: If using SetEnv.cmd to set up MS SDK env (no longer needed even for compiling GS2 with debug):
+
+::call "C:\Program Files\Microsoft SDKs\Windows\v7.1\Bin\SetEnv.cmd"
+:: Run with /? to see what options it takes (/x86, /x64, /ia64, /vista, /xp, /win7 and more)
+
+::set sdklocation=C:\Program Files\Microsoft SDKs\Windows\v7.1\Bin
+::if not exist "%sdklocation%" echo %sdklocation% does not exist& goto done
+::pushd "%sdklocation%"
+::call SetEnv.cmd /x64
+::popd
+
+
+:done
+echo Done
+echo ******************************
+echo.
+