Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/util/GSXML.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/util/GSXML.java	(revision 32433)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/util/GSXML.java	(revision 32434)
@@ -652,5 +652,5 @@
 		{ // this line is an attempted solution to the NullPointerException mentioned 
 			// in trac bug ticket #225. If n is null can't do n.getFirstChild() below. As per bug #225: 
-			// GSXML.getNodeByPath() is called by GS2BrowseAction, which then calls this method.
+			// getNodeByPath() is called by GS2BrowseAction, which then calls this method.
 			// If n is null, null will be returned which GS2BrowseAction already checks for. It's here
 			// that the NullPointerException was thrown.
@@ -952,7 +952,7 @@
 	public static Element createBasicResponse(Document owner, String from)
 	{
-		Element response = owner.createElement(GSXML.RESPONSE_ELEM);
-		response.setAttribute(GSXML.FROM_ATT, from);
-		response.setAttribute(GSXML.TYPE_ATT, GSXML.REQUEST_TYPE_PROCESS);
+		Element response = owner.createElement(RESPONSE_ELEM);
+		response.setAttribute(FROM_ATT, from);
+		response.setAttribute(TYPE_ATT, REQUEST_TYPE_PROCESS);
 		return response;
 	}
@@ -960,7 +960,7 @@
 	public static Element createMetadataElement(Document owner, String name, String value)
 	{
-		Element metaElem = owner.createElement(GSXML.METADATA_ELEM);
-		metaElem.setAttribute(GSXML.NAME_ATT, name);
-		metaElem.setAttribute(GSXML.VALUE_ATT, value);
+		Element metaElem = owner.createElement(METADATA_ELEM);
+		metaElem.setAttribute(NAME_ATT, name);
+		metaElem.setAttribute(VALUE_ATT, value);
 		return metaElem;
 	}
@@ -1031,5 +1031,5 @@
 		p.setAttribute(NAME_ATT, id);
 		p.setAttribute(TYPE_ATT, type);
-		p.appendChild(createDisplayTextElement(owner, GSXML.DISPLAY_TEXT_NAME, display_name));
+		p.appendChild(createDisplayTextElement(owner, DISPLAY_TEXT_NAME, display_name));
 
 		if (default_value != null)
@@ -1043,5 +1043,5 @@
 				Element e = owner.createElement(PARAM_OPTION_ELEM);
 				e.setAttribute(NAME_ATT, option_ids[i]);
-				e.appendChild(createDisplayTextElement(owner, GSXML.DISPLAY_TEXT_NAME, option_names[i]));
+				e.appendChild(createDisplayTextElement(owner, DISPLAY_TEXT_NAME, option_names[i]));
 				p.appendChild(e);
 			}
@@ -1056,5 +1056,5 @@
 		p.setAttribute(NAME_ATT, id);
 		p.setAttribute(TYPE_ATT, type);
-		p.appendChild(createDisplayTextElement(owner, GSXML.DISPLAY_TEXT_NAME, display_name));
+		p.appendChild(createDisplayTextElement(owner, DISPLAY_TEXT_NAME, display_name));
 		if (default_value != null)
 		{
@@ -1067,5 +1067,5 @@
 				Element e = owner.createElement(PARAM_OPTION_ELEM);
 				e.setAttribute(NAME_ATT, option_ids.get(i));
-				e.appendChild(createDisplayTextElement(owner, GSXML.DISPLAY_TEXT_NAME, option_names.get(i)));
+				e.appendChild(createDisplayTextElement(owner, DISPLAY_TEXT_NAME, option_names.get(i)));
 				p.appendChild(e);
 			}
@@ -1138,5 +1138,5 @@
 		MyNodeList result = new MyNodeList();
 
-		NodeList matchingNodes = GSXML.getNamedElementsNS(parent, namespace_uri, node_local_name, attribute_names[0], attribute_values[0]);
+		NodeList matchingNodes = getNamedElementsNS(parent, namespace_uri, node_local_name, attribute_names[0], attribute_values[0]);
 		for (int i = 0; i < matchingNodes.getLength(); i++)
 		{
@@ -1165,5 +1165,5 @@
 	public static void removeElementsWithAttributesNS(Element parent, String namespace_uri, String node_local_name, String[] attribute_names, String[] attribute_values)
 	{
-		NodeList matchingNodes = GSXML.getElementsWithAttributesNS(parent, namespace_uri, node_local_name, attribute_names, attribute_values);
+		NodeList matchingNodes = getElementsWithAttributesNS(parent, namespace_uri, node_local_name, attribute_names, attribute_values);
 		for (int i = 0; i < matchingNodes.getLength(); i++)
 		{
@@ -1184,5 +1184,5 @@
 		}
 
-		Element old_elem = GSXML.getNamedElementNS(parent, namespace_uri, node_local_name, attribute_name, attribute_value);
+		Element old_elem = getNamedElementNS(parent, namespace_uri, node_local_name, attribute_name, attribute_value);
 		if (old_elem != null)
 		{
@@ -1662,5 +1662,5 @@
 		ArrayList<String> groups = new ArrayList<String>();
 
-		Element groupList = (Element) GSXML.getChildByTagName(securityResponse, GSXML.GROUP_ELEM + GSXML.LIST_MODIFIER);
+		Element groupList = (Element) getChildByTagName(securityResponse, GROUP_ELEM + LIST_MODIFIER);
 		if (groupList == null)
 		{
@@ -1668,10 +1668,10 @@
 		}
 
-		NodeList groupElems = GSXML.getChildrenByTagName(groupList, GSXML.GROUP_ELEM);
+		NodeList groupElems = getChildrenByTagName(groupList, GROUP_ELEM);
 
 		for (int i = 0; i < groupElems.getLength(); i++)
 		{
 			Element groupElem = (Element) groupElems.item(i);
-			groups.add(groupElem.getAttribute(GSXML.NAME_ATT));
+			groups.add(groupElem.getAttribute(NAME_ATT));
 		}
 